# Coverflow

I used the following resources to make this:

- [An early coverflow in action](https://512pixels.net/wp-content/uploads/2023/10/Original-CoverFlow.mov) from [512 Pixels](https://512pixels.net/2023/10/the-history-of-cover-flow/)
- [Another coverflow in action](https://vimeo.com/56512656) that appears and behaves differently than the above ([source](https://medium.com/@michaeldain/interface-hero-jon-del-strother-and-coverflow-9411bf73e01b))
- [Addy Osmani post](https://addyosmani.com/blog/jqueryuicoverflow/)
- [This trick](https://discourse.vvvv.org/t/recognize-mouse-click-but-only-on-the-specified-layer/22687/9) for hit test

Libraries I used beside Skia:

- [VL.PolyTools](https://github.com/TobyKLight/VL.PolyTools)

Extra knowledge that I found but didn't apply in the project:

- I could've drawn images in an offscreen render with solid colors for each art and done image sampling to identify on which album art my cursor over
  - suggested here https://openrndr.discourse.group/t/do-skew-perspective-transform-on-a-rectangle-and-then-check-if-a-mouse-cursor-is-on-it/723/2?u=ajitid
  - also suggested in Generative Design with P5.js | P_2_1_4_01 in http://www.generative-gestaltung.de/2/ | alt. link https://editor.p5js.org/generative-design/sketches/Bytll99qaJ4
- [Made me discover the terms: affine and non-affine transformation](https://stackoverflow.com/questions/48416118/perspective-transform-in-skia)
  - This knowledge might still be useful later as it asks about vertices <-> matrix conversion and transformation
- [Shows internal SKMatrix to Matrix transformation logic in vvvv](http://discourse.vvvv.org/t/skia-non-affine-transforms-not-displaying-properly/18116/2)
- Matrix scale, transform and rotate
  - https://youtu.be/nl74u9X3ZuE?si=8RW2U144P-DSNVXy
  - https://www.youtube.com/watch?v=HgQzOmnBGCo
  - https://www.khanacademy.org/math/algebra-home/alg-matrices/alg-matrices-as-transformations/v/matrix-transformation-triangle
- How to check if a point is in a polygon
  - [Explanation](https://youtu.be/01E0RGb2Wzo?si=0nrXcXtZWYtZ-6yE)
  - [Another explanation](https://observablehq.com/@tmcw/understanding-point-in-polygon) by tmcw
  - [An implementation](https://stackoverflow.com/questions/217578/how-can-i-determine-whether-a-2d-point-is-within-a-polygon#comment26837632_217578) I found in the comments
  - [Wikipedia article](https://www.wikiwand.com/en/Point_in_polygon)
  - [Other methods](https://medium.com/@girishajmera/exploring-algorithms-to-determine-points-inside-or-outside-a-polygon-038952946f87)
  - There's patch in Help Browser of vvvv › Learn › Search for "touch" > Under Skia there is MultiTouch. In it, if you open "Create _Slide_" that is at the top left in the patch by middle clicking, then open RectContainsPoint which is at the very bottom. This is a custom operation node and in it you'd see that the co-ordinate of mouse cursor inversely transformed to check if intersects the rectangle on the screen. I did not use this mostly because:
    - I wasn't sure if it would still work with a non-affine transformation or not
    - I also got to know that [matrices can change from row-major to column-major](https://youtu.be/pYu3DiWYtL0?si=50FptUq0Xui6TTjS&t=916) (though that didn't really matter as I had [this info](http://discourse.vvvv.org/t/skia-non-affine-transforms-not-displaying-properly/18116/2))
