// For examples, see:
// https://thegraybook.vvvv.org/reference/extending/writing-nodes.html#examples

namespace Main;

public static class Utils
{
    // taken from https://github.com/ajitid/exploring-interfaces/blob/main/src/petha/snap.ts
    public static int SnappedIndex(float[] points, float value)
    {
        if (points.Length == 0)
        {
            throw new Exception("At least one item needs to be present for this to work.");
        }

        float lastDistance = Math.Abs(points[0] - value);

        for (int i = 1; i < points.Length; i++)
        {
            float distance = Math.Abs(points[i] - value);

            if (distance == 0) return i;

            if (distance > lastDistance) return i - 1;

            if (i == points.Length - 1) return i;

            lastDistance = distance;
        }

        // should never happen
        throw new Exception("Index not found.");
    }
}